// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using concurrency::array;
using concurrency::accelerator;
using concurrency::array_view;
using concurrency::parallel_for_each;
using concurrency::extent;
using concurrency::index;
using std::cout;
using std::vector;
using std::string;

int gnx, gny, gnz;
double gLx, gLy, gLz;
double gx, gy, gz;

double gOutInterval;
double gt;
double gNextOutTime;
double gTime;
double gFinTime;

accelerator gAcc;
array<double , 1> *gpF, *gpFN;

vector<double> gvF;
int main()
{
    cout << "calcurate\n";
    //
    gnx = 32;
    gny = 32;
    gnz = 32;

    gLx = 1;
    gLy = 1;
    gLz = 1;

    gx = gLx / gnx;
    gy = gLy / gny;
    gz = gLz / gnz;

    gt = 0.0001;
    gOutInterval = 0.001;
    gFinTime = 0.1;
    gTime = 0;
    gNextOutTime = 0;

    gAcc = ChoseAccelerator();

    gpF = new array<double, 1>((gnx + 2)*(gny + 2)*(gnz + 2), gAcc.get_default_view());
    gpFN = new array<double, 1>((gnx + 2)*(gny + 2)*(gnz + 2), gAcc.get_default_view());

    array_view<double, 1> aF = *gpF;
    double x = gx;
    double y = gy;
    double z = gz;

    int nx, ny, nz, mx, my, mz;
    nx = gnx;
    ny = gny;
    nz = gnz;
    mx = gnx+2;
    my = gny+2;
    mz = gnz+2;
    parallel_for_each(
        gAcc.get_default_view(),
        extent<3>(gnx,gny,gnz),
        [=](index<3> iR) restrict(amp)
    {
        int i, j, k;
        double x, y, z;
        index<1> iC;
        i = iR[0]+1;
        j = iR[1]+1;
        k = iR[2]+1;

        iC[0] = i*mx*mz + j*mz + k;

        aF[iC] = 0;
    }
    );
    while (true)
    {
        //E̐ݒ
        {
            array_view<double, 1> aF = *gpF;

            nx = gnx;
            ny = gny;
            nz = gnz;
            mx = gnx + 2;
            my = gny + 2;
            mz = gnz + 2;
            parallel_for_each(
                gAcc.get_default_view(),
                extent<2>(my,mz),
                [=](index<2> iR) restrict(amp)
            {
                int i, j, k;
                double x, y, z;
                index<1> iC,iV;
                i = 1;
                j = iR[0];
                k = iR[1];

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] - my*mz;

                aF[iV] = -1-aF[iC];


                i = nx;

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] + my*mz;

                aF[iV] = 1-aF[iC];
            }
            );
            parallel_for_each(
                gAcc.get_default_view(),
                extent<2>(mx, mz),
                [=](index<2> iR) restrict(amp)
            {
                int i, j, k;
                double x, y, z;
                index<1> iC, iV;
                i = iR[0];
                j = 1;
                k = iR[1];

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] - mz;

                aF[iV] = aF[iC];

                i = iR[0];
                j = ny;
                k = iR[1];

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] + mz;

                aF[iV] = aF[iC];
            }
            );
            parallel_for_each(
                gAcc.get_default_view(),
                extent<2>(mx, my),
                [=](index<2> iR) restrict(amp)
            {
                int i, j, k;
                double x, y, z;
                index<1> iC, iV;
                i = iR[0];
                j = iR[1];
                k = 1;

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] - 1;

                aF[iV] = aF[iC];

                k = nz;

                iC[0] = i*my*mz + j*mz + k;
                iV[0] = iC[0] + 1;

                aF[iV] = aF[iC];
            }
            );
        }
        if (gNextOutTime < gTime + gt)
        {
            gvF = *gpF;
            //o
            FILE* fp;
            char str[300];
            float fr[3];
            
            sprintf(str, "res%d.vtk", lroundl(gTime/ gOutInterval));
            fp = fopen(str, "w+b");
            fprintf(fp, "# vtk DataFile Version 3.0\n");
            fprintf(fp, "vtk output\n");
            fprintf(fp, "BINARY\n");
            fprintf(fp, "DATASET STRUCTURED_GRID\n");
            fprintf(fp, "DIMENSIONS %d %d %d\n", gnx + 1, gny + 1, gnz + 1);

            //iq_̏
            fprintf(fp, "POINTS %d float\n", (gnx + 1)*(gny + 1)*(gnz + 1));
            for (int i = 0; i < gnx + 1; i++)
                for (int j = 0; j < gny + 1; j++)
                    for (int k = 0; k < gnz + 1; k++)
                    {
                        fr[0] = i*gx;
                        fr[1] = j*gy;
                        fr[2] = k*gz;

                        str[0] = ((char*)fr)[3 + 0];
                        str[1] = ((char*)fr)[2 + 0];
                        str[2] = ((char*)fr)[1 + 0];
                        str[3] = ((char*)fr)[0 + 0];
                        str[4] = ((char*)fr)[3 + 4];
                        str[5] = ((char*)fr)[2 + 4];
                        str[6] = ((char*)fr)[1 + 4];
                        str[7] = ((char*)fr)[0 + 4];
                        str[8] = ((char*)fr)[3 + 8];
                        str[9] = ((char*)fr)[2 + 8];
                        str[10] = ((char*)fr)[1 + 8];
                        str[11] = ((char*)fr)[0 + 8];

                        fwrite(str, 1, 12, fp);
                    }
            fprintf(fp, "POINT_DATA %d\n", (gnx + 1)*(gny + 1)*(gnz + 1));

            fprintf(fp, "SCALARS F float\n");
            fprintf(fp, "LOOKUP_TABLE default\n");

            for (int i = 0; i < gnx + 1; i++)
                for (int j = 0; j < gny + 1; j++)
                    for (int k = 0; k < gnz + 1; k++)
                    {
                        fr[0] = i*gx;
                        fr[1] = j*gy;
                        fr[2] = k*gz;

                        int iC, iN, iE, iNE, iH, iNH, iEH, iNEH;
                        iC = i*(gny + 2)*(gnz + 2) + j *(gnz + 2) + k;
                        iN = iC + gnz + 2;
                        iE = iC + (gny + 2)*(gnz + 2);
                        iNE = iE + gnz + 2;
                        iH = iC + 1;
                        iNH = iN + 1;
                        iEH = iE + 1;
                        iNEH = iNE + 1;

                        fr[0] = (gvF[iC] + gvF[iE] + gvF[iN] + gvF[iNE] 
                            + gvF[iH] + gvF[iEH] + gvF[iNH] + gvF[iNEH])/8;
                        str[0] = ((char*)fr)[3 + 0];
                        str[1] = ((char*)fr)[2 + 0];
                        str[2] = ((char*)fr)[1 + 0];
                        str[3] = ((char*)fr)[0 + 0];

                        fwrite(str, 1, 4, fp);
                    }
            fclose(fp);
            gNextOutTime += gOutInterval;
        }

        //gU
        {
            array_view<double, 1> aF = *gpF;
            array_view<double, 1> aFN = *gpFN;

            double x, y, z, t;
            x = gx;
            y = gy;
            z = gz;
            t = gt;
            
            int mx, my, mz;

            mx = gnx + 2;
            my = gny + 2;
            mz = gnz + 2;
            parallel_for_each(
                gAcc.get_default_view(),
                extent<3>(gnx, gny, gnz),
                [=](index<3> iR) restrict(amp)
            {
                int i, j, k;
                double x, y, z;
                index<1> iC, iN,iH,iE,iS,iW,iL;
                i = iR[0]+1;
                j = iR[1]+1;
                k = iR[2]+1;

                iC[0] = i*my*mz + j*mz + k;
                iN[0] = iC[0] + mz;
                iH[0] = iC[0] + 1;
                iE[0] = iC[0] + my*mz;
                iS[0] = iC[0] - mz;
                iW[0] = iC[0] - my*mz;
                iL[0] = iC[0] - 1;

                aFN[iC] = aF[iC] + t*((aF[iE] - 2 * aF[iC] + aF[iW]) / (x*x) +
                    (aF[iN] - 2 * aF[iC] + aF[iS]) / (y*y) +
                    (aF[iH] - 2 * aF[iC] + aF[iL]) / (z*z));
            }
            );
        }

        array<double> *pTemp;
        pTemp = gpF;
        gpF = gpFN;
        gpFN = pTemp;

        gTime += gt;

        if (gTime > gFinTime)
            break;
    }
    return 0;
}

